"""
    Copyright 2006,2007 Riccardo Taormina (den3b@hotmail.com)
    
    This file is part of SmartChameleons.

    SmartChameleons is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    SmartChameleons is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with SmartChameleons; if not, write to the Free Software
    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA

"""

#Class Chameleon
import random


class Chameleon:
    def __init__(self,number,color,graphItem,worldXSize=80,worldYSize=80):
        self.number = number
        self.color = color
        self.xPosition = random.randint(0,worldXSize-1)
        self.yPosition = random.randint(0,worldYSize-1)
        self.worldXSize = worldXSize
        self.worldYSize = worldYSize
        self.justChanged = False
        self.graphItem = graphItem
        
        #for the new reward algorithm
        self.firstReward = 0
        self.secondReward = 0
        self.waitingForReward = False
        self.firstAction = 0
        self.secondAction = 0
        self.states = [[0]*25,[0]*25,[0]*25]
        self.waitingForLastReward = False
        
        
    def talk(self):
        print "[ ch",self.number,"] --- I'm in position X =",self.xPosition,\
              " , Y = ",self.yPosition, " and my color is ", self.color

    def move(self):
        self.xPosition += randomMove()
        self.yPosition += randomMove()
        self.xPosition = (self.worldXSize + self.xPosition) % self.worldXSize
        self.yPosition = (self.worldYSize + self.yPosition) % self.worldYSize

    def smartMove(self,positionChanges):
        self.xPosition += positionChanges[0]
        self.yPosition += positionChanges[1]
        self.xPosition = (self.worldXSize + self.xPosition) % self.worldXSize
        self.yPosition = (self.worldYSize + self.yPosition) % self.worldYSize

    def changeColor(self,newColor):
        #print "[ ch",self.number,"] --- I'm changing from ", self.color, " to ", newColor
        #print
        self.color = newColor
        self.justChanged = True

    def hasntJustChanged(self):
        return not self.justChanged

def randomMove():
    return random.randint(-1,1)



