"""
    Copyright 2006,2007 Riccardo Taormina (den3b@hotmail.com)
    
    This file is part of SmartChameleons.

    SmartChameleons is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    SmartChameleons is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with SmartChameleons; if not, write to the Free Software
    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA

"""

import pickle
from NN import *

def getInputs():
    global nCycles
    while 1:
        mode = raw_input("Choose (T = Train, R = Run ; q to quit) > ")
        if mode == "q":
            quit()
        elif mode == "T":
            [maxX,maxY,nCycles,nChams]=getEnviInputs()
            [brain,path,smartColor,seed]=manageTrain()
            print seed
            return mode,maxX,maxY,nCycles,nChams,brain,path,smartColor,seed
            break
        elif mode == "R":
            [maxX,maxY,nCycles,nChams]=getEnviInputs()
            [brain,path,smartColor,seed]=manageRun()
            print seed
            return mode,maxX,maxY,nCycles,nChams,brain,path,smartColor,seed
            break
        else :
            continue


def getEnviInputs():
    while 1:
        try :
            maxX = input("Insert the environment WIDTH > ")
        except NameError:
            print "You must enter a number between 1 and 20"
            continue
        if maxX >0 and maxX<=200:
            break
        else :
            print "You must enter a number between 1 and 20"
            
        
    while 1:
        try :
            maxY = input("Insert the environment HEIGHT > ")
        except NameError:
            print "You must enter a number between 1 and 20"
            continue
        if maxY >0 and maxY<=200:
            break
        else :
            print "You must enter a number between 1 and 20"

    while 1:
        try :
            nCycles = input("Numer of Cycles  > ")
        except NameError:
            print "You must enter a number between 1 and 10^6"
            continue
        if nCycles >0 and nCycles<=1000000:
            break
        else :
            print "You must enter a number between 1 and 10^6"

    while 1:
        try :
            nChams = input("Chameleons for each color  > ")
        except NameError:
            print "You must enter a number between 1 and " + str(maxX*maxY/3)
            continue
        if nChams >0 and nChams<= maxX*maxY/3:
            break
        else :
            print "You must enter a number between 1 and " + str(maxX*maxY/3)

    return int(maxX),int(maxY),int(nCycles),int(nChams)



def manageTrain():
    while 1:
        sel = raw_input("Insert N to create a new brain, "\
                        "M to modify an existing brain; q to quit > ")
        if sel == "N":
            while 1:
                path = raw_input("Write the name of the new file (without extension) > ") + ".bra"
                if fileExist(path):
                    sel = raw_input("The file " + path + " already exists'. Overwrite (Y/N)? > ")
                    if sel == "Y" :
                        break
                    else :
                        continue
                else :
                    break
            while 1:
                nHidden = input("Number of hidden layer neurons?  > ")
                if nHidden > 50 or nHidden <1 :
                    print "The number should be between 1 and 50. Try again. "
                    continue
                else :
                    break
            brain = []
            for i in range(9):
                brain.append(Net([25,nHidden,1]))
            break
                
        elif sel == "M":
            while 1:
                path = raw_input("Write the name of the file to load and modify (without extension) > ") + ".bra"
                if fileExist(path):
                    brainFile = open(path, 'rb')
                    brain = pickle.load(brainFile)
                    brainFile.close()
                    break
                else :
                    print "The file " + path + " doesn't exist. Try again"
            break

    color = 'red'
    while 1 :
        try:
            seed = input ("Choose a seed for the Random class (press ENTER for 12345) > ")
            break
        except SyntaxError:
            seed = 12345
            break
        except NameError:
            print "Please insert an integer"

    return brain,path,color,int(seed)
            

def manageRun():
    while 1:
        path = raw_input("Write the name of the ""brain"" file to use (without extension) > ") + ".bra"
        if fileExist(path):
            brainFile = open(path, 'rb')
            brain = pickle.load(brainFile)
            brainFile.close()
            break
        else :
            print "The file " + path + " doesn't exist. Try again"
    color = ''
    colorList = ["blue","green","red"]
    while colorList.count(color) == 0:
        color = raw_input("The smart chamaleons are (write blue,green or red) > ")

    while 1 :
        try:
            seed = input ("Choose a seed for the Random class (press ENTER for 12345) > ")
            break
        except SyntaxError:
            seed = 12345
            break
        except NameError:
            print "Please insert an integer"


    return brain,path,color,int(seed)
    

def loadBrain(path):
    brainFile = open(path, 'rb')
    brain = pickle.load(brainFile)
    brainFile.close()
    return brain

def storeBrain(brain, path):
    brainFile=open(path,'wb')
    pickle.dump(brain, brainFile)
    brainFile.close
    print "The brain has been stored to " + path


def fileExist(path):
    try:
        file_=open(path,"rb")
        file_.close()
        return 1
    except IOError:
        return 0
