"""
    Copyright 2006,2007 Riccardo Taormina (den3b@hotmail.com)
    
    This file is part of SmartChameleons.

    SmartChameleons is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    SmartChameleons is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with SmartChameleons; if not, write to the Free Software
    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA

"""

"""
    From an idea of Marco Lamieri, developed by Riccardo Taormina.
    The code is written according to a python simplified version of the
    SWARM protocol (www.swarm.org), devised by Pietro Terna.

    Rules : 3 different groups of chameleons, colored RED, BLUE and GREEN, move
    in a toroidal space. When two chameleons of different colors collide, they
    both shift to the 3rd color. The steady state is achieved when all chameleons
    are of the same color.
    If they are all left to move randomly, the final result is always
    unpredictable and the system generally doesn't reach the steady state,
    even for long times.
    Things change if a BRAIN is associated with one of the three colors, suggesting
    the smart chameleons which is the best move to perform in each situation.
    The probability of reaching the steady state greatly increases, in advantage
    of the "smart color".

    Here the brain is created via a Connectionist Reinforcement Learning and a
    trial and error procedure. New BRAINS could be created with StartChameleons
    in the batchChameleons directory. The StartChameleons in the guiChameleons
    allows experiments to be made via a graphic interface and a default brain.

    Since most of the code in the files of both directories is the same, please
    refer to those in guiChameleons for comments.
    
"""


#START_CHAMELEONs
from Observer import *

observer = Observer()

# build the objects
observer.buildObjects()

# build the actions
observer.buildActions()

# run
observer.run()
    
    
