"""
    Copyright 2006,2007 Riccardo Taormina (den3b@hotmail.com)
    
    This file is part of SmartChameleons.

    SmartChameleons is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    SmartChameleons is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with SmartChameleons; if not, write to the Free Software
    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA

"""

#GUI
from Tkinter import *
from tkFont import *
from thread import *

class Panel(Toplevel):
    def __init__(self,parent):
        Toplevel.__init__(self,parent)

        self.title("Control Panel")
        
        self.parent = parent
        self.smartColor = StringVar()


        self.protocol("WM_DELETE_WINDOW", self.quit)
        self.resizable(False,False)

        self.frame1=Frame(self)
        self.frame2=Frame(self.frame1,relief=RAISED,borderwidth=1)
        self.frame3=Frame(self.frame1,relief=RAISED,borderwidth=1)

        myFont = Font(family="Terminal", size=10, weight = BOLD)

        self.create_b = Button(self.frame1,font = myFont,text = "Create", width=20, command = self.create,height = 1)
        self.quit_b = Button(self.frame1,font = myFont, text = "Quit", command = self.quit,height = 1)
        self.go_b = Button(self.frame1,font = myFont,text = "Go", command = self.go, state = DISABLED,height = 1)
        self.out_b = Button(self.frame1,font = myFont,text = "Show output", width=20, command = self.output,state = NORMAL,height = 1)
        self.stop_b = Button(self.frame1,font = myFont,text = "Stop", command = self.stop,state = DISABLED,height = 1)
        self.step_b = Button(self.frame1,font = myFont,text = "Step", command = self.step,state = DISABLED,height = 1)
        self.envi_b = Button(self.frame1,font = myFont,text = "Show environment", width=20, command = self.showEnvi,state = NORMAL, height = 1)

        self.create_b.grid(row=0,column= 0,sticky = W+E+N+S)
        self.quit_b.grid(row=0,column=1,sticky = W+E+N+S)
        self.go_b.grid(row=0,column=2,sticky = W+E+N+S)
        self.out_b.grid(row=1,column= 0,sticky = W+E+N+S)
        self.stop_b.grid(row=1,column=1,sticky = W+E+N+S)
        self.step_b.grid(row=1,column=2,sticky = W+E+N+S)
        self.envi_b.grid(row=2,column = 0,sticky = W+E+N+S)

        self.frame1.grid(row=0,column=0)
        self.frame2.grid(row=0,column=3,rowspan=3,sticky=N+S)
        self.frame3.grid(row=2,column=1,columnspan=2,sticky=W+E+N+S)

        Label(self.frame3, text="Smart Color : ").grid(row=0,column=0)
        Radiobutton(self.frame3,text="None", variable=self.smartColor, value="",command = self.setSmartColor).grid(row=0,column=1)
        Radiobutton(self.frame3,text="Red", variable=self.smartColor, value="red",command = self.setSmartColor).grid(row=0,column=2)
        Radiobutton(self.frame3,text="Blue", variable=self.smartColor, value="blue",command = self.setSmartColor).grid(row=0,column=3)
        Radiobutton(self.frame3,text="Green",variable=self.smartColor, value="green",command = self.setSmartColor).grid(row=0,column=4)


        self.speed = Scale(self.frame2,label = "Speed", command = self.getSpeed, state = DISABLED, from_=1, to = 5)
        self.speed.grid(row=0,column=0,sticky=N+S)
        self.frequency = Scale(self.frame2,label = "Refresh Frequency", command = self.getFrequency, state = DISABLED, from_=1, to = 10)
        self.frequency.grid(row=0,column=1,sticky=N+S)


    def create(self):
                
        self.go_b["state"]="normal"
        self.step_b["state"]="normal"
        self.stop_b["state"]="disabled"
        self.create_b["state"]="disabled"
        self.speed["state"]="normal"
        self.frequency["state"]="normal"

        self.parent.create()

    def quit(self):
        self.parent.quit()

    def stop(self):
        self.parent.stopIt = True
        self.step_b["state"]="normal"
        self.go_b["state"]="normal"

    def go(self):
        self.parent.stopIt = False
        self.go_b["state"]="disabled"
        self.step_b["state"]="disabled"
        self.stop_b["state"]="normal"
        self.parent.go()
        


    def step(self):
        self.parent.step()

    def getSpeed(self,event):
        self.parent.speed = self.speed.get()

    def getFrequency(self,event):
        self.parent.refreshFrequency = self.frequency.get()

    def setSmartColor(self):
        self.parent.smartColor = self.smartColor.get()

    def cancel(self):
        self.destroy()
        self.parent.destroy()

    def output(self):
        if self.parent.output.state() == "withdrawn": 
            self.parent.output.deiconify()
        else :
             self.parent.output.withdraw()

    def showEnvi(self):
        if self.parent.state()=="withdrawn":
            self.parent.deiconify()
        else :
            self.parent.withdraw()
    
            
        


